#include "queue.h"
#include "configuration.h"

#include <iostream>

using namespace std;


// Make a queue.

Queue::Queue()
{
    head = NULL;
}


// Dispose the contents of the queue.

Queue::~Queue()
{
    if (head)
    {
        head->deleteContents();
        delete head;
    }
}


// Add config to the queue. 

void Queue::enqueue(Configuration *config)
{
    static int inserts = 0;
    
    ConfigurationList *cl = new ConfigurationList(config, NULL);
    
    if (!head)
        head = tail = cl;                   // it's empty
    else
    {
        tail->next = cl;        
        tail = cl;
    }
    
    // simple progress indicator
    
    if (!(++inserts % 1000))
        cout << '.' << flush;
}


// Remove & return the head of the queue.

Configuration *Queue::dequeue()
{
    ConfigurationList *oldhead = head;
    Configuration *result = head->config;
    head = head->next;
    
    delete oldhead;
        
    return result;
}


// Is the queue empty?

bool Queue::empty()
{
    return !head;
}


// Is there a configuration in the queue matching a given configuration?

bool Queue::isPresent(Configuration *match)
{
    return head && head->isPresent(match);
}
